compar.c File Reference
`#include "ruby/ruby.h"`

Go to the source code of this file.

## Macros

#define | rb_intern(str) rb_intern_const(str)

## Functions

void | rb_cmperr (VALUE x, VALUE y)
static VALUE | cmp_eq (VALUE *a)
static VALUE | cmp_failed (void)
static VALUE | cmp_equal (VALUE x, VALUE y)
static VALUE | cmp_gt (VALUE x, VALUE y)
static VALUE | cmp_ge (VALUE x, VALUE y)
static VALUE | cmp_lt (VALUE x, VALUE y)
static VALUE | cmp_le (VALUE x, VALUE y)
static VALUE | cmp_between (VALUE x, VALUE min, VALUE max)
void | Init_Comparable (void)

## Variables

VALUE | rb_mComparable
static ID | cmp

## Macro Definition Documentation

#define rb_intern | ( |  | str | ) | rb_intern_const(str)

## Function Documentation

static VALUE cmp_between | ( | VALUE | x,
|  | VALUE | min,
|  | VALUE | max
| ) |  |

static

Definition at line 154 of file compar.c.

References cmp_gt(), cmp_lt(), Qfalse, Qtrue, and RTEST.

Referenced by Init_Comparable().

static VALUE cmp_eq | ( | VALUE * | a | ) |

static

Definition at line 35 of file compar.c.

References cmp, NIL_P, Qfalse, Qtrue, rb_cmpint(), and rb_funcall().

Referenced by cmp_equal().

static VALUE cmp_equal | ( | VALUE | x,
|  | VALUE | y
| ) |  |

static

Definition at line 60 of file compar.c.

References cmp_eq(), cmp_failed(), Qtrue, and rb_rescue().

Referenced by Init_Comparable().

static VALUE cmp_failed | ( | void |  | ) |

static

Definition at line 45 of file compar.c.

References Qfalse.

Referenced by cmp_equal().

static VALUE cmp_ge | ( | VALUE | x,
|  | VALUE | y
| ) |  |

static

Definition at line 96 of file compar.c.

References cmp, Qfalse, Qtrue, rb_cmpint(), and rb_funcall().

Referenced by Init_Comparable().

static VALUE cmp_gt | ( | VALUE | x,
|  | VALUE | y
| ) |  |

static

Definition at line 79 of file compar.c.

References cmp, Qfalse, Qtrue, rb_cmpint(), and rb_funcall().

Referenced by cmp_between(), and Init_Comparable().

static VALUE cmp_le | ( | VALUE | x,
|  | VALUE | y
| ) |  |

static

Definition at line 130 of file compar.c.

References cmp, Qfalse, Qtrue, rb_cmpint(), and rb_funcall().

Referenced by Init_Comparable().

static VALUE cmp_lt | ( | VALUE | x,
|  | VALUE | y
| ) |  |

static

Definition at line 113 of file compar.c.

References cmp, Qfalse, Qtrue, rb_cmpint(), and rb_funcall().

Referenced by cmp_between(), and Init_Comparable().

void Init_Comparable | ( | void |  | ) |

Definition at line 201 of file compar.c.

References cmp, cmp_between(), cmp_equal(), cmp_ge(), cmp_gt(), cmp_le(), cmp_lt(), rb_define_method(), rb_define_module(), rb_intern, and rb_mComparable.

void rb_cmperr | ( | VALUE | x,
|  | VALUE | y
| ) |  |

Definition at line 19 of file compar.c.

References classname(), rb_eArgError, rb_inspect(), rb_obj_classname(), rb_raise(), SPECIAL_CONST_P, and StringValuePtr.

Referenced by int_downto(), int_upto(), rb_cmpint(), and rb_num_coerce_relop().

## Variable Documentation

ID cmp

static

Definition at line 16 of file compar.c.

Referenced by cmp_eq(), cmp_ge(), cmp_gt(), cmp_le(), cmp_lt(), Init_Comparable(), max_i(), max_ii(), min_i(), min_ii(), num_step(), and rb_mod_cmp().

VALUE rb_mComparable

Definition at line 14 of file compar.c.

Referenced by Init_Comparable(), Init_date_core(), Init_File(), Init_Numeric(), Init_ossl_x509name(), Init_String(), and Init_Time().